
CoCoALib - Feature #966
Status: Closed Start date: 10 Nov 2016

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Documentation Estimated time: 2.22 hours

Target version: CoCoALib-0.99700 Spent time: 2.15 hours

Description

In CoCoA-5 we often first and last for making sub-lists.

This is tedious to translate into C++.

Make good C++ documentation, or write a trivial/inefficient function for handy-handling of short lists.

Related issues:

Related to CoCoALib - Feature #357: Constructor for vectors?  CoCoAVector Rejected 24 May 2013

History

#1 - 10 Nov 2016 09:05 - Anna Maria Bigatti

- Related to Feature #357: Constructor for vectors?  CoCoAVector added

#2 - 10 Nov 2016 09:06 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

Equivalent to first,last:

vector<RingElem>(x.begin(), x.end()-1))

vector<RingElem>(x.begin()+2, x.end()))

#3 - 10 Nov 2016 16:11 - John Abbott

I am not yet convinced that first and last are good ideas for C++.

What exactly are the hoped-for semantics?  Maybe last can be implemented relatively efficiently, but I have doubts about first.

I am concerned that they may make wasteful copies of the elements of the list/vector.

#4 - 10 Nov 2016 19:05 - Anna Maria Bigatti

John Abbott wrote:

I am concerned that they may make wasteful copies of the elements of the list/vector.

 

Surely they do make wasteful copies.  That's why I wrote "short lists" ;-)

Anyway, I'm adding some examples in ex-c++.
#5 - 05 Aug 2018 16:19 - Anna Maria Bigatti

- Category changed from New Function to Documentation

- Status changed from New to In Progress

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99650 November 2019

- % Done changed from 0 to 20

#6 - 05 Aug 2018 16:19 - Anna Maria Bigatti

- Subject changed from New function: first and last for a vector? to New function or explain: first and last for a vector?

#7 - 01 Oct 2019 12:10 - John Abbott

- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-0.99700

#8 - 13 Jan 2020 18:34 - Anna Maria Bigatti

- Status changed from In Progress to Resolved

- % Done changed from 20 to 70

OK, I think we should not make a function in lib.

I added an example in ex-c++.C.

Now I realized that there is a ex-c++-vector.C, so I think my original example should be split into the specific example files.

... not today.

In time for next release?  not sure.

#9 - 14 Feb 2020 10:21 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 70 to 100

- Estimated time changed from 3.00 h to 2.22 h

I have moved the example into a new file ex-c++-vector2.C which illustrates how to "translate" the CoCoA-5 functions append, first and last into

C++.

Powered by TCPDF (www.tcpdf.org)

20 Apr 2024 2/2

http://www.tcpdf.org

